/*
 *    Copyright (c) 2018-2025, lengleng All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * Neither the name of the yifu4cloud.com developer nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this software without specific prior written permission.
 * Author: lengleng (wangiegie@gmail.com)
 */

package com.yifu.cloud.plus.v1.yifu.archives.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.yifu.cloud.plus.v1.yifu.archives.entity.FeedBackDetail;
import com.yifu.cloud.plus.v1.yifu.archives.entity.TEmpContractAlert;
import com.yifu.cloud.plus.v1.yifu.archives.vo.*;
import com.yifu.cloud.plus.v1.yifu.common.core.util.ErrorMessage;
import com.yifu.cloud.plus.v1.yifu.common.core.util.R;

import javax.servlet.http.HttpServletResponse;
import java.io.InputStream;
import java.util.List;

/**
 * 员工合同续签待办
 *
 * @author fxj
 * @date 2022-07-01 14:15:05
 */
public interface TEmpContractAlertService extends IService<TEmpContractAlert> {

	/**
	 * 员工合同续签待办简单分页查询
	 * @param tEmpContractAlert 员工合同续签待办
	 * @return
	 */
	IPage<ContractAlertAutoVo> getTEmpContractAlertAutoPage(Page<TEmpContractAlert> page, ContractAlertSearchVo tEmpContractAlert);

	IPage<TEmpContractAlert> pageDiy(Page page, ContractAlertSearchVo searchVo);
	// 给自动化用的-合同待续签-分页查询
	IPage<TEmpContractAlert> getAutoPage(Page page, ContractAlertSearchVo searchVo);
	// 合同待续签数量查询
	long getAutoContractCount(ContractAlertSearchVo searchVo);

	List<TEmpContractAlert> noPageToAuto(ContractAlertSearchVo searchVo);
	List<TEmpContractAlert> listDiy(ContractAlertSearchVo searchVo);

    void listExport(HttpServletResponse response, ContractAlertSearchVo searchVo);
	/**
	 * 定时任务生成合同续签代码信息
	 * @return R<List>
	 * @Author FXJ
	 * @Date 2022-07-4
	 **/
	R<Boolean> taskCreateContractAlert();
	

	boolean changeFeedBackAll(ChangeFeedBackAllVo changeFeedBackAllVo);
    

	List<FeedBackDetail> getFeedbackDetail(String applyNo);

	/**
	 * @Description: 批量更新-合同续签待办
	 * @Author: hgw
	 * @Date: 2023-7-17 09:46:40
	 **/
	R<List<EmpContractAlertUpdateVO>> batchUpdate(InputStream inputStream);

	R<List<ErrorMessage>> importDiy(InputStream inputStream);

    void pushContractAlertToWx();

	Integer getTEmpContractAlertAutoCount(ContractAlertSearchVo tEmpContractAlert);

	void listAutoExport(HttpServletResponse response, ContractAlertSearchVo searchVo);

	EmpProjectVO getProjectInfoByContractId(String id);

	R<EmpContractRenewVO> getAllRenewInfoById(String id);

	R<List<ContractAlertConfirmVo>> getAutoRenewForConfirm(ContractAlertSearchVo tEmpContractAlert);
}
